/**
 * jQuery.QQWorldOpen - Easy Content Show For jQuery
 * Copyright (c) 2010-2011 QQWorld | http://qqworld.org
 * Date: 4/1/2012
 * @author Michael Q Wang
 * @version 1.0.0
 *
 * http://project.qqworld.org
 */
(function ($) {
$.fn.QQWorldOpen = function (options) {
	var defaults = {
		itemTag: 'li',
		openClass: '.open',
		speed: 500,
		direction: 'random', //default: "random", include "up", "down", "left", "right", 'right_up', 'right_down', 'left_down', 'left_up'
		easing: 'random'
	};
	var opts = $.extend(defaults, options);

	var _this = this;
	//top 移动量, left 移动量
	var T, L;
	//方向, 方向數組
	var direction, directionArray = new Array('up', 'down', 'left', 'right', 'right_up', 'right_down', 'left_down', 'left_up');
	//easomg
	var easing, easingTypes = new Array("swing", "easeInQuad", "easeOutQuad", "easeInOutQuad", "easeInCubic", "easeOutCubic", "easeInOutCubic", "easeInQuart", "easeOutQuart", "easeInOutQuart", "easeInQuint", "easeOutQuint", "easeInOutQuint", "easeInSine", "easeOutSine", "easeInOutSine", "easeInExpo", "easeOutExpo", "easeInOutExpo", "easeInCirc", "easeOutCirc", "easeInOutCirc", "easeInElastic", "easeOutElastic", "easeInOutElastic", "easeInBack", "easeOutBack", "easeInOutBack", "easeInBounce", "easeOutBounce", "easeInOutBounce");
	
	//库
	var lib = {};
	//创建从under到over的随机整数
	lib.randomBy = function(under, over) {
		switch(arguments.length){
			case 1: {
				return parseInt(Math.random()*under+1);
				break;
			}
			case 2: {
				return parseInt(Math.random()*(over-under+1) + under);
				break;
			}
			default: {
				return 0;
				break;
			}
		};
	};
		
	//-------------------------------------------------------------------------------------------------
	//控制层
	this.controls = {};
	//播放
	this.controls.play = function() {		
		$(_this).children(opts.itemTag).hover(
			function() {
				_this.controls.getValue($(this));
				eval("$(this).find(opts.openClass).stop().animate({ top: '" + T + "', left: '" + L + "' }, opts.speed, $(this).data('easing'))");
			},
			function() {
				eval("$(this).find(opts.openClass).stop().animate({ top: 0, left: 0 }, opts.speed, $(this).data('easing'))");
			}
		)
	};
	//获取对应方向的各参数值
	this.controls.getValue = function(obj) {
		switch (obj.data('direction')) {
			case 'up':
				T = '-' + obj.data('height') + 'px';
				L = 0;
				break;
			case 'down':
				T = obj.data('height') + 'px';
				L = 0;
				break;
			case 'left':
				T = 0;
				L = '-' + obj.data('width') + 'px';
				break;
			case 'right':
				T = 0;
				L = obj.data('width') + 'px';
				break;
			case 'right_up':
				T = '-' + obj.data('height') + 'px';
				L = obj.data('width') + 'px';
				break;
			case 'right_down':
				T = obj.data('height') + 'px';
				L = obj.data('width') + 'px';
				break;
			case 'left_down':
				T = obj.data('height') + 'px';
				L = '-' + obj.data('width') + 'px';
				break;
			case 'left_up':
				T = '-' + obj.data('height') + 'px';
				L = '-' + obj.data('width') + 'px';
				break;
		}
	};

	//-------------------------------------------------------------------------------------------------
	//视觉层
	this.create = {};

	//控制li的css属性
	this.create.css = function() {
		$(_this).find(opts.openClass).css({
			position: 'absolute',
			top: 0,
			left: 0
		})
	};
	this.create.container = function(obj) {
		var QQWorldOpen = document.createElement('QQWorldOpen');
		QQWorldOpen.style.width = obj.data('width') + "px";
		QQWorldOpen.style.height = obj.data('height') + "px";
		QQWorldOpen.style.overflow = "hidden";
		QQWorldOpen.style.position = "absolute";
		obj.wrapInner(QQWorldOpen);
	};
	this.create.data = function() {
		$(_this).children(opts.itemTag).each(function() {
			$(this).data('width', $(this).width());
			$(this).data('height', $(this).height());
			direction = opts.direction == 'random' ? directionArray[lib.randomBy(0,directionArray.length-1)] : opts.direction;
			$(this).data('direction', direction);
			easing = opts.easing == 'random' ? easingTypes[lib.randomBy(0, easingTypes.length-1)] : opts.easing;
			$(this).data('easing', easing);
			_this.create.container($(this));
		});
	};

	//初始化，建立幻灯项目数组，预载图片
	var init = function() {
		_this.create.css();
		_this.create.data();
		_this.controls.play();
	};
	init();
	return this;
};
})(jQuery);